%{
// **********************************************************************
// Simple scanner specification.
// **********************************************************************
%}

DIGIT		[0-9]
LETTER		[a-zA-Z]
WHITESPACE	[ \t]

%{
#include <string>
#include <stdlib.h>
#include <math.h>
#include <values.h>
#include "message.h"
#include "ast.h"
#include "scanner.h"
#include "gram.tab.h"	/* token definitions etc.
	 		 * this file will be generated from grammar spec by
			 * bison
			 */

int col_num = 1;
int row_num = 1;
%}

%%

"//".*\n			{
				    //cout << "Saw a comment" << endl;
				    row_num++; col_num=1;
				 }

\n				    row_num++, col_num=1;


"int"                               {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
                                         return(INTEGER);
                                    }
"float"                             {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
                                         return(FLOAT);
                                    }
"bool"                              {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
                                         return(BOOLEAN);
                                    }
"String"                            {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
                                        return(STRING);
                                    }
"void"                              {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
                                         return(VOID);
                                    }
"true"                              {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
                                         return(TRUE);
                                    }
"false"                             {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
                                         return(FALSE);
                                    }
"if"                                {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
                                         return(IF);
                                    }
"else"                              {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
                                         return(ELSE);
                                    }
"while"                             {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
                                         return(WHILE);
                                    }
"write"                             {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
                                         return(WRITE);
                                    }
"return"                            {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(RETURN);
                                    }
"{"                                 {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
                                      return(LCURLY);
                                    }
"}"				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(RCURLY);
				    }

"("				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(LPAREN);
				    }
")"				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(RPAREN);
				    }
","				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(COMMA);
				    }
"="				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(ASSIGN);
				    }
";"				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(SEMICOLON);
				    }
"+"				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(PLUS);
				    }
"-"				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(MINUS);
				    }
"*"				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(TIMES);
				    }
"/"				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(DIVIDE);
				    }
"!"				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(NOT);
				    }
"&&"				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(AND);
				    }
"||"				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(OR);
				    }
"=="				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(EQUALS);
				    }
"!="				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(NOTEQUALS);
				    }
"<"				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(LESS);
				    }
">"				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(GREATER);
				    }
"<="				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(LESSEQ);
				    }
">="				    {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
					col_num += yyleng;
					return(GREATEREQ);
				    }
["]([^\n"\\]|[\\][^\n])*["]       {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
                                      yylval.TOKENval.strVal = new string(yytext);
					col_num += yyleng;
				      return(STRINGLITERAL);
                                    }
["]([^\n"\\]|[\\][^\n])*[\\]? 		{
					ReportError(row_num, col_num, "Unterminated string");
                                    }
({LETTER}|_)({LETTER}|{DIGIT}|_)*   {
                                         yylval.TOKENval.lineNum = row_num;
					 yylval.TOKENval.colNum = col_num;
                                      yylval.TOKENval.strVal = new string(yytext);
					col_num += yyleng;
				      return(ID);
                                    }
{DIGIT}+			    {
						yylval.TOKENval.lineNum = row_num;
						yylval.TOKENval.colNum = col_num;
						col_num += yyleng;
						double d;
						d = atof(yytext);
						if( d > MAXINT) 
						{
							ReportWarning(row_num, col_num, "int literal too big, using MAXINT");
							d = MAXINT;
						}
						yylval.TOKENval.intVal = (int)d;
						return(INTLITERAL);
					}						 
{DIGIT}*[.]{DIGIT}+			    {
						yylval.TOKENval.lineNum = row_num;
						yylval.TOKENval.colNum = col_num;
						col_num += yyleng;
						double d;
						d = atof(yytext);
						if( d > MAXFLOAT) 
						{
							ReportWarning(row_num, col_num, "float literal too big, using MAXFLOAT");
							d = MAXFLOAT;
						}
						if( d < MINFLOAT) 
						{
							ReportWarning(row_num, col_num, "float literal too big, using MINFLOAT");
							d = MINFLOAT;
						}
						yylval.TOKENval.floatVal = float(d);
						return(FLOATLITERAL);
					}						 
{WHITESPACE}+			    { col_num +=yyleng;}


.				    { ReportError(row_num, col_num, "Illegal character!"); }
%%
